
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Chat_participantsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_participants = await db.chat_participants.create(
            {
                id: data.id || undefined,
        
        role: data.role
        ||
        null
            ,
            
        joined_at: data.joined_at
        ||
        null
            ,
            
        is_muted: data.is_muted
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await chat_participants.setConversation( data.conversation || null, {
            transaction,
        });
        
        await chat_participants.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return chat_participants;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const chat_participantsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                role: item.role
            ||
            null
            ,
            
                joined_at: item.joined_at
            ||
            null
            ,
            
                is_muted: item.is_muted
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const chat_participants = await db.chat_participants.bulkCreate(chat_participantsData, { transaction });

        // For each item created, replace relation files
        

        return chat_participants;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const chat_participants = await db.chat_participants.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.role !== undefined) updatePayload.role = data.role;
        
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        if (data.is_muted !== undefined) updatePayload.is_muted = data.is_muted;
        
        
        updatePayload.updatedById = currentUser.id;

        await chat_participants.update(updatePayload, {transaction});

        
        
        if (data.conversation !== undefined) {
            await chat_participants.setConversation(
              
              data.conversation,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await chat_participants.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return chat_participants;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_participants = await db.chat_participants.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of chat_participants) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of chat_participants) {
                await record.destroy({transaction});
            }
        });


        return chat_participants;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const chat_participants = await db.chat_participants.findByPk(id, options);

        await chat_participants.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await chat_participants.destroy({
            transaction
        });

        return chat_participants;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const chat_participants = await db.chat_participants.findOne(
            { where },
            { transaction },
        );

        if (!chat_participants) {
            return chat_participants;
        }

        const output = chat_participants.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conversation = await chat_participants.getConversation({
            transaction
        });
        
        
        output.user = await chat_participants.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.chat_conversations,
        as: 'conversation',
        
        where: filter.conversation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conversation.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.conversation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role) {
                where = {
                    ...where,
                role: filter.role,
            };
            }
            
            if (filter.is_muted) {
                where = {
                    ...where,
                is_muted: filter.is_muted,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.chat_participants.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'chat_participants',
                        'role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.chat_participants.findAll({
            attributes: [ 'id', 'role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.role,
        }));
    }

    
};

